<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/unwinder_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>02/03/84  unwinder_
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>
<span id="L4" class="LineNr"> 4 </span>Entry points in unwinder_:
<span id="L5" class="LineNr"> 5 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L6" class="LineNr"> 6 </span>
<span id="L7" class="LineNr"> 7 </span>
<span id="L8" class="LineNr"> 8 </span>:Entry: unwinder_: 02/03/84  unwinder_
<span id="L9" class="LineNr"> 9 </span>
<span id="L10" class="LineNr">10 </span>
<span id="L11" class="LineNr">11 </span>Function: is used to perform a nonlocal goto on the Multics stack.  It
<span id="L12" class="LineNr">12 </span>is not intended to be called by direct programming <span class="textRainbow_lv0_p0">(</span>i.e.<span class="textRainbow_lv0_o0">,</span> an explicit
<span id="L13" class="LineNr">13 </span>call statement in a program<span class="textRainbow_lv0_p0">)</span> but rather, by the generated code of a
<span id="L14" class="LineNr">14 </span>translator.  For example, it is automatically invoked by a PL/I goto
<span id="L15" class="LineNr">15 </span>statement involving a nonlocal label variable.
<span id="L16" class="LineNr">16 </span>
<span id="L17" class="LineNr">17 </span>
<span id="L18" class="LineNr">18 </span>Syntax:
<span id="L19" class="LineNr">19 </span>declare unwinder_ entry <span class="textRainbow_lv0_p0">(</span>label<span class="textRainbow_lv0_p0">)</span>;
<span id="L20" class="LineNr">20 </span>call unwinder_ <span class="textRainbow_lv0_p0">(</span>tag<span class="textRainbow_lv0_p0">)</span>;
<span id="L21" class="LineNr">21 </span>
<span id="L22" class="LineNr">22 </span>
<span id="L23" class="LineNr">23 </span>Arguments:
<span id="L24" class="LineNr">24 </span>tag
<span id="L25" class="LineNr">25 </span>   is a nonlocal label variable.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L26" class="LineNr">26 </span>
<span id="L27" class="LineNr">27 </span>
<span id="L28" class="LineNr">28 </span>Notes: When invoked, the unwinder_ subroutine traces the Multics stack
<span id="L29" class="LineNr">29 </span>backward until it finds the stack frame associated with its label
<span id="L30" class="LineNr">30 </span>variable argument or until the stack is exhausted.  In each stack
<span id="L31" class="LineNr">31 </span>frame it passes, it invokes the handler <span class="textRainbow_lv0_p0">(</span>if any<span class="textRainbow_lv0_p0">)</span> for the cleanup
<span id="L32" class="LineNr">32 </span>condition.  When it finds the desired stack frame, it passes control
<span id="L33" class="LineNr">33 </span>to the procedure associated with that frame at the location indicated
<span id="L34" class="LineNr">34 </span>by the label variable argument.  If the desired stack frame cannot be
<span id="L35" class="LineNr">35 </span>found or if other obscure error conditions arise <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> the stack is
<span id="L36" class="LineNr">36 </span>not threaded correctly<span class="textRainbow_lv0_p0">)</span>, the unwinder_ subroutine signals the
<span id="L37" class="LineNr">37 </span>unwinder_error condition.  If the target is not on the current stack,
<span id="L38" class="LineNr">38 </span>and there is a stack in a higher ring, that stack is searched after
<span id="L39" class="LineNr">39 </span>the current one is unwound.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
